Merge "Define PRODUCT_PRODUCT_VNDK_VERSION as current by default" into main
diff --git a/cogsetup.sh b/cogsetup.sh
new file mode 100644
index 0000000..02fcc8f
--- /dev/null
+++ b/cogsetup.sh
@@ -0,0 +1,89 @@
+#
+# Copyright (C) 2023 The Android Open Source Project
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+
+# This file is executed by build/envsetup.sh, and can use anything
+# defined in envsetup.sh.
+function _create_out_symlink_for_cog() {
+ if [[ "${OUT_DIR}" == "" ]]; then
+ OUT_DIR="out"
+ fi
+
+ if [[ -L "${OUT_DIR}" ]]; then
+ return
+ fi
+ if [ -d "${OUT_DIR}" ]; then
+ echo -e "\tOutput directory ${OUT_DIR} cannot be present in a Cog workspace."
+ echo -e "\tDelete \"${OUT_DIR}\" or create a symlink from \"${OUT_DIR}\" to a directory outside your workspace."
+ return 1
+ fi
+
+ DEFAULT_OUTPUT_DIR="${HOME}/.cog/android-build-out"
+ mkdir -p ${DEFAULT_OUTPUT_DIR}
+ ln -s ${DEFAULT_OUTPUT_DIR} `pwd`/out
+}
+
+# This function moves the reclient binaries into a directory that exists in a
+# non-cog part of the overall filesystem. This is to workaround the problem
+# described in b/289391270.
+function _copy_reclient_binaries_from_cog() {
+ local NONCOG_RECLIENT_BIN_DIR="${HOME}/.cog/reclient/bin"
+ if [ ! -d "$NONCOG_RECLIENT_BIN_DIR" ]; then
+ # Create the non cog directory if it doesn't exist.
+ mkdir -p ${NONCOG_RECLIENT_BIN_DIR}
+ else
+ # Clear out the non cog directory if it does exist.
+ rm -f ${NONCOG_RECLIENT_BIN_DIR}/*
+ fi
+
+ local TOP=$(gettop)
+
+ # Copy the binaries out of live.
+ cp $TOP/prebuilts/remoteexecution-client/live/* $NONCOG_RECLIENT_BIN_DIR
+
+ # Finally set the RBE_DIR env var to point to the out-of-cog directory.
+ export RBE_DIR=$NONCOG_RECLIENT_BIN_DIR
+}
+
+# This function sets up the build environment to be appropriate for Cog.
+function _setup_cog_env() {
+ _create_out_symlink_for_cog
+ if [ "$?" -eq "1" ]; then
+ echo -e "\e[0;33mWARNING:\e[00m Cog environment setup failed!"
+ return 1
+ fi
+ _copy_reclient_binaries_from_cog
+
+ export ANDROID_BUILD_ENVIRONMENT_CONFIG="googler-cog"
+
+ # Running repo command within Cog workspaces is not supported, so override
+ # it with this function. If the user is running repo within a Cog workspace,
+ # we'll fail with an error, otherwise, we run the original repo command with
+ # the given args.
+ ORIG_REPO_PATH=`which repo`
+ function repo {
+ if [[ "${PWD}" == /google/cog/* ]]; then
+ echo "\e[01;31mERROR:\e[0mrepo command is disallowed within Cog workspaces."
+ return 1
+ fi
+ ${ORIG_REPO_PATH} "$@"
+ }
+}
+
+if [[ "${PWD}" != /google/cog/* ]]; then
+ echo -e "\e[01;31mERROR:\e[0m This script must be run from a Cog workspace."
+fi
+
+_setup_cog_env
\ No newline at end of file
diff --git a/core/product_config.mk b/core/product_config.mk
index bc3e7765..b475d75 100644
--- a/core/product_config.mk
+++ b/core/product_config.mk
@@ -282,7 +282,11 @@
#############################################################################
# Check product include tag allowlist
-BLUEPRINT_INCLUDE_TAGS_ALLOWLIST := com.android.mainline_go com.android.mainline
+BLUEPRINT_INCLUDE_TAGS_ALLOWLIST := \
+ com.android.mainline_go \
+ com.android.mainline \
+ mainline_module_prebuilt_nightly \
+ mainline_module_prebuilt_monthly_release
.KATI_READONLY := BLUEPRINT_INCLUDE_TAGS_ALLOWLIST
$(foreach include_tag,$(PRODUCT_INCLUDE_TAGS), \
$(if $(filter $(include_tag),$(BLUEPRINT_INCLUDE_TAGS_ALLOWLIST)),,\
@@ -293,7 +297,8 @@
# we still analyse it.
# This means that in setups where we two have two prebuilts of module_sdk, we need a "default" to use in analysis
# This should be a no-op in aosp and internal since no Android.bp file contains blueprint_package_includes
-PRODUCT_INCLUDE_TAGS += com.android.mainline # Use the big android one by default
+# Use the big android one and main-based prebuilts by default
+PRODUCT_INCLUDE_TAGS += com.android.mainline mainline_module_prebuilt_nightly
endif
#############################################################################
diff --git a/envsetup.sh b/envsetup.sh
index 0a90460..63837ec 100644
--- a/envsetup.sh
+++ b/envsetup.sh
@@ -2006,6 +2006,11 @@
fi
done
done
+
+ if [[ "${PWD}" == /google/cog/* ]]; then
+ f="build/make/cogsetup.sh"
+ echo "including $f"; . "$T/$f"
+ fi
}
function showcommands() {
diff --git a/target/product/base_vendor.mk b/target/product/base_vendor.mk
index d22f71f..3c4d62e 100644
--- a/target/product/base_vendor.mk
+++ b/target/product/base_vendor.mk
@@ -46,7 +46,7 @@
# Base modules and settings for the vendor partition.
PRODUCT_PACKAGES += \
- com.android.hardware.cas \
+ android.hardware.cas-service.example \
boringssl_self_test_vendor \
dumpsys_vendor \
fs_config_files_nonsystem \
diff --git a/tools/aconfig/src/codegen_cpp.rs b/tools/aconfig/src/codegen_cpp.rs
index 177587d..5eadf2a 100644
--- a/tools/aconfig/src/codegen_cpp.rs
+++ b/tools/aconfig/src/codegen_cpp.rs
@@ -364,6 +364,7 @@
const TEST_SOURCE_FILE_EXPECTED: &str = r#"
#include "com_android_aconfig_test.h"
#include <server_configurable_flags/get_flags.h>
+#include <unordered_map>
namespace com::android::aconfig::test {
diff --git a/tools/aconfig/src/codegen_java.rs b/tools/aconfig/src/codegen_java.rs
index 23e2cd8..702ef22 100644
--- a/tools/aconfig/src/codegen_java.rs
+++ b/tools/aconfig/src/codegen_java.rs
@@ -177,23 +177,23 @@
}
@Override
public boolean disabledRo() {
- return getFlag(Flags.FLAG_DISABLED_RO);
+ return getValue(Flags.FLAG_DISABLED_RO);
}
@Override
public boolean disabledRw() {
- return getFlag(Flags.FLAG_DISABLED_RW);
+ return getValue(Flags.FLAG_DISABLED_RW);
}
@Override
public boolean enabledFixedRo() {
- return getFlag(Flags.FLAG_ENABLED_FIXED_RO);
+ return getValue(Flags.FLAG_ENABLED_FIXED_RO);
}
@Override
public boolean enabledRo() {
- return getFlag(Flags.FLAG_ENABLED_RO);
+ return getValue(Flags.FLAG_ENABLED_RO);
}
@Override
public boolean enabledRw() {
- return getFlag(Flags.FLAG_ENABLED_RW);
+ return getValue(Flags.FLAG_ENABLED_RW);
}
public void setFlag(String flagName, boolean value) {
if (!this.mFlagMap.containsKey(flagName)) {
@@ -206,7 +206,7 @@
entry.setValue(null);
}
}
- private boolean getFlag(String flagName) {
+ private boolean getValue(String flagName) {
Boolean value = this.mFlagMap.get(flagName);
if (value == null) {
throw new IllegalArgumentException(flagName + " is not set");
@@ -250,7 +250,7 @@
}
@Override
public boolean disabledRw() {
- return DeviceConfig.getBoolean(
+ return getValue(
"aconfig_test",
"com.android.aconfig.test.disabled_rw",
false
@@ -266,12 +266,33 @@
}
@Override
public boolean enabledRw() {
- return DeviceConfig.getBoolean(
+ return getValue(
"aconfig_test",
"com.android.aconfig.test.enabled_rw",
true
);
}
+ private boolean getValue(String nameSpace,
+ String flagName, boolean defaultValue) {
+ boolean value = defaultValue;
+ try {
+ value = DeviceConfig.getBoolean(
+ nameSpace,
+ flagName,
+ defaultValue
+ );
+ } catch (NullPointerException e) {
+ throw new RuntimeException(
+ "Cannot read value of flag " + flagName + " from DeviceConfig. " +
+ "It could be that the code using flag executed " +
+ "before SettingsProvider initialization. " +
+ "Please use fixed read-only flag by adding " +
+ "is_fixed_read_only: true in flag declaration.",
+ e
+ );
+ }
+ return value;
+ }
}
"#;
let mut file_set = HashMap::from([
diff --git a/tools/aconfig/templates/FakeFeatureFlagsImpl.java.template b/tools/aconfig/templates/FakeFeatureFlagsImpl.java.template
index d4283d3..e4a1fb7 100644
--- a/tools/aconfig/templates/FakeFeatureFlagsImpl.java.template
+++ b/tools/aconfig/templates/FakeFeatureFlagsImpl.java.template
@@ -12,7 +12,7 @@
{{ for item in class_elements}}
@Override
public boolean {item.method_name}() \{
- return getFlag(Flags.FLAG_{item.flag_name_constant_suffix});
+ return getValue(Flags.FLAG_{item.flag_name_constant_suffix});
}
{{ endfor}}
public void setFlag(String flagName, boolean value) \{
@@ -28,7 +28,7 @@
}
}
- private boolean getFlag(String flagName) \{
+ private boolean getValue(String flagName) \{
Boolean value = this.mFlagMap.get(flagName);
if (value == null) \{
throw new IllegalArgumentException(flagName + " is not set");
diff --git a/tools/aconfig/templates/FeatureFlagsImpl.java.template b/tools/aconfig/templates/FeatureFlagsImpl.java.template
index 1736af9..3913fa4 100644
--- a/tools/aconfig/templates/FeatureFlagsImpl.java.template
+++ b/tools/aconfig/templates/FeatureFlagsImpl.java.template
@@ -9,7 +9,7 @@
@Override
public boolean {item.method_name}() \{
{{ -if item.is_read_write }}
- return DeviceConfig.getBoolean(
+ return getValue(
"{item.device_config_namespace}",
"{item.device_config_flag}",
{item.default_value}
@@ -19,6 +19,29 @@
{{ endif- }}
}
{{ endfor }}
+{{ if is_read_write- }}
+ private boolean getValue(String nameSpace,
+ String flagName, boolean defaultValue) \{
+ boolean value = defaultValue;
+ try \{
+ value = DeviceConfig.getBoolean(
+ nameSpace,
+ flagName,
+ defaultValue
+ );
+ } catch (NullPointerException e) \{
+ throw new RuntimeException(
+ "Cannot read value of flag " + flagName + " from DeviceConfig. " +
+ "It could be that the code using flag executed " +
+ "before SettingsProvider initialization. " +
+ "Please use fixed read-only flag by adding " +
+ "is_fixed_read_only: true in flag declaration.",
+ e
+ );
+ }
+ return value;
+ }
+{{ endif- }}
}
{{ else }}
{#- Generate only stub if in test mode #}
diff --git a/tools/aconfig/templates/cpp_source_file.template b/tools/aconfig/templates/cpp_source_file.template
index f373bc6..c0e7343 100644
--- a/tools/aconfig/templates/cpp_source_file.template
+++ b/tools/aconfig/templates/cpp_source_file.template
@@ -2,6 +2,9 @@
{{ if readwrite }}
#include <server_configurable_flags/get_flags.h>
{{ endif }}
+{{ if for_test }}
+#include <unordered_map>
+{{ endif }}
namespace {cpp_namespace} \{